<?php
/**
* Plugin Name: HoweScape Scout Book Label Print
* Plugin URI: http://howescape.com/
* Description: Plugin to import ScoutBook CSV file to PDF 
* Version: 0.0.1
* Author: P.T.Howe
* Text Domain: hs_ScoutBookLabelPrint
* Domain Path: /languages
* Author URI: http://HoweScape.com/
* License: GPL2
*/

	// Constants
	include_once ( plugin_dir_path( __FILE__ ) . "./include/hs_ScoutBookLabelPrint_constants.php");
	
	include_once ( plugin_dir_path( __FILE__ ) . "fpdf.php" );
		
class hs_ScoutBookLabelPrint_pdf extends FPDF {
	// Extend the FPDF, Define function to override the header
	// This allows a title and page number to be included.
	static $fileNameLocal = "";
	static $pagenum = 1;
	
	function SetTitleFileName ($inFileName) {
		global $fileNameLocal;
		global $pagenum;
		
		$fileName = $inFileName;
		$fileNameLocal = $fileName;
		$pagenum = 1;
	}
	
	function Header() {
		global $fileNameLocal;
		global $pagenum;
		$headerHeight = 2; 
		// Select Arial bold 15
		$this->SetFont('Arial','B',9);
		// Move to the right
		$this->Cell(126,$headerHeight," ");
		// Framed title
		$this->Cell(126,$headerHeight,$fileNameLocal,0,0,'C');
		$this->Cell(126,$headerHeight,"Page: ".$pagenum,0,0,'R');
		$pagenum = $pagenum + 1;
		// Line break
		$this->Ln(5);
	}
}
	
class hs_ScoutBookLabelPrint {

	function load_custom_wp_admin_style($hook) {
        // Load only on ?page=mypluginname
        if($hook != 'toplevel_page_mypluginname') {
                return;
        }
//        wp_enqueue_style( 'custom_wp_admin_css', 'load_js_css' );
	}
	
	function load_js_css($hook) {
//		wp_register_style ( 'prefix-style', plugins_url('include/hs_ScoutBookLabelPrint_style.css', __FILE__));
		wp_register_style ( 'hs_ScoutBookLabelPrint', plugins_url('include/hs_ScoutBookLabelPrint_style.css', __FILE__));
		wp_enqueue_style( 'hs_ScoutBookLabelPrint' );	
	}

	function hs_ScoutBookLabelPrint_loadCouncil($selectedCouncil) {
		$councils = array();
		$keys = array();
		$values = array();
		$councilXML = plugin_dir_path( __FILE__ )."include/CouncilList.xml";
		$xml = simplexml_load_file($councilXML);
		$firstTag = $xml->getName();
		if (strcmp($firstTag, HS_SBLP_ROOT) == 0) {
			foreach ($xml->children() as $rootChildren) {
				$councilName = $rootChildren->getName(); 
				//echo ("Council1: ".$councilName."<br>");
				if (strcmp($councilName, HS_SBLP_COUNCILLIST) == 0) {
					//echo ("councilname 1.5: <br>");
					foreach ($rootChildren->children() as $councilEntry) {
						$councilName2 = $councilEntry->getName();
						//echo (" council2:".$councilName2."<br>");
						foreach ($councilEntry->children() as $councilFields) {
							if (strcmp($councilFields->getName(), HS_SBLP_NAME) == 0) {
								$councilName = $councilFields;
								//echo "<Option value='".$councilFields."'>".$councilFields."</Option>";
							} elseif (strcmp ($councilFields->getName(), HS_SBLP_NUMBER) == 0) {
								$councilNumber = $councilFields;
							}
						}
						$keys[] = $councilNumber;
						$values[] = $councilName;
						//$working = array($councilNumber."=>".$councilName);
						//$councils = array_merge($councils, $working);
						//array_push($councils, $working);
						//$councils[] = $working;
					}
				}
			}
		}
		$councils = array_combine($keys, $values);
//		echo " before: <br>";
//		foreach ($councils as $a => $b) {
//			echo (" a: ".$a." = ".$b."<br>");
//		}
		$sortResult = asort($councils, SORT_STRING);
//		if (sortResult == True) {
//		echo ('SortResult TRUE:'.$sortResult);
//		} else {
//		echo ('SortResult FALSE:'.$sortResult);
//		}

//		echo " after: <br>";
//		foreach ($councils as $a => $b) {
//			echo (" a: ".$a." = ".$b."<br>");
//		}
//		$arrlength = count($councils);
		foreach ($councils as $a => $b) {		
			if (strcmp($selectedCouncil, $b) == 0){
				$selected = 'selected="selected"';
			} else {
				$selected = '';
			}
			echo "<Option value='".$b."' ".$selected." >".$b." - ".$a."</Option>";
		}
	}
	
	function hs_ScoutBookLabelPrint_loadXML() {
		$dropdownValues = array();
		
		$generalXML = plugin_dir_path( __FILE__ )."include/ScoutBook_DropDown.xml";
		$xml = simplexml_load_file($generalXML);
		$firstTag = $xml->getName();
		//echo ("First: ".$firstTag."<br>");
		if (strcmp($firstTag, HS_SBLP_GENERAL) == 0) {
			foreach ($xml->children() as $rootChildren) {
				//echo ("Children: ".$rootChildren."<br>");
				if (strcmp($rootChildren->getName(), HS_SBLP_FONTS) == 0) {
					foreach ($rootChildren->children() as $fontsChildren) {
						//echo ("Font Children: ".$fontsChildren."<br>");
						$dropdownValues[] = $fontsChildren;
					}
				} elseif (strcmp($rootChildren->getName(), HS_SBLP_UNITS) == 0) {
					foreach ($rootChildren->children() as $unitsChildren) {
						//echo ("Unit Children: ".$unitsChildren."<br>");
						$dropdownValues[] = "".$unitsChildren."";
					}
				} elseif (strcmp($rootChildren->getName(), HS_SBLP_RANKMSG) == 0) {
					$dropdownValues[] = $rootChildren;
				} elseif (strcmp($rootChildren->getName(), HS_SBLP_MBMSG) == 0) {
					$dropdownValues[] = $rootChildren;
				} elseif (strcmp($rootChildren->getName(), HS_SBLP_ABBRLIST) == 0) {
					foreach ($rootChildren->children() as $meritBadgeChilren) {
						// mb abbr.
						foreach ($meritBadgeChilren->children() as $mbc) {
							//echo "MB: ".$meritBadgeChilren."<br>";
							if (strcmp($mbc->getName(),HS_SBLP_NAME) == 0) {
								$fullName = $mbc;
							} elseif (strcmp($mbc->getName(), HS_SBLP_ABBR) == 0) {
								$abbrName = $mbc;
							}
						}
						//echo " both: ".$fullName.";".$abbrName."<br>";
						$dropdownValues[] = $fullName.";".$abbrName; 
					}
				}
				$dropdownValues[] = -1;
			}
		}

		return $dropdownValues;
	}
	
	function hs_ScoutBookLabelPrint_loadFonts($xmlValues) {
		global	$fontSize;
		//$selectedFont = $_COOKIE['HS_COOKIE_SBLP_FontSize'];
		$selectedFont = $fontSize;
		foreach ($xmlValues as $singleRow) {
			//echo ("Single:".$singleRow."<br>");
			if (strcmp($selectedFont, $singleRow) == 0){
				$selected = 'selected="selected"';
			} else {
				$selected = '';
			}	
			if ($singleRow != -1 ) {
				echo "<Option value='".$singleRow."' ".$selected." >".$singleRow."</Option>";
			} else {
				break;
			}
		}
	}
	
	function hs_ScoutBookLabelPrint_loadUnits ( $xmlValues, $unitType ) {
		$isUnitValue = FALSE;
		//$selectedUnit = $_COOKIE[HS_COOKIE_SBLP_UnitType];
		$selectedUnit = $unitType;
		foreach ($xmlValues as $singleRow) {
			if (strcmp($selectedUnit, $singleRow) == 0){
				$selected = 'selected="selected"';
			} else {
				$selected = '';
			}
			if ($isUnitValue == TRUE && $singleRow != -1) { 
				echo "<Option value='".$singleRow."' ".$selected." >".$singleRow."</Option>";
			} elseif ($isUnitValue == TRUE && $singleRow == -1) {
				break;
			} elseif ($singleRow == -1) {
				$isUnitValue = TRUE;
			}
		}
	}
	
	function hs_ScoutBookLabelPrint_loadMsg( $xmlValues, $index, $inMsg) {
		$isRankValue = FALSE;
		$isFlagCount = 0;
		if (strlen($inMsg) == 0) {
			foreach ($xmlValues as $singleRow) {
				if ($singleRow == -1) { 
					$isFlagCount = $isFlagCount + 1;
				} elseif ($isFlagCount == $index) {
					$singleRow = str_replace('\n', '&lt;n&gt;', $singleRow);
					$singleRow = str_replace('\rank', '&lt;rank&gt;', $singleRow);
					$singleRow = str_replace('\mb_name', '&lt;mb_name&gt;', $singleRow);
					echo $singleRow;
					break;
				} 
			}
		} else {
			echo $inMsg;
		}
	}
		
	function hs_ScoutBookLabelPrint_loadMB($xmlValues) {
		$mbList = array();
		$isMBListValue = FALSE;
		$subListCount = 0;
		//$selectedUnit = $_COOKIE[HS_COOKIE_SBLP_UnitType];
		foreach ($xmlValues as $singleRow) {
			//echo ("list-lmb: ".$singleRow." count: ".$subListCount."<br>");
			if ($isMBListValue == TRUE && $singleRow != -1 && $subListCount >= 3) { 
				$mbList[] = $singleRow;
			} elseif ($isMBListValue == FALSE && $singleRow == -1) {
				$subListCount = $subListCount + 1;
				if ($subListCount >=4) {
					$isMBListValue = TRUE;
				}
			} elseif ($subListCount >= 4) {
				$isMBListValue = TRUE;
			}
		}
//		foreach($mbList as $a) {
//			echo (' list:'.$a.'<br>');
//		}
		return $mbList;
	}
	
	function hs_ScoutBookLabelPrint_loadTemplate() {
		$generalXML = plugin_dir_path( __FILE__ )."include/Labels-templates.xml";
		$xml = simplexml_load_file($generalXML);
		$firstTag = $xml->getName();
		
	}
	
	function hs_ScoutBookLabelPrint_placeRowLabels () {
		global	$pdf;
		global	$lineLabels;
		
		// NX =4, NY = 8
		// x0 = 36pt, y0=36pt
		// dx = 129.536pt
		// dy = 90pt
		//$stickerHeight = 31.75; // MM (1.25 inch)
		$stickerHeight = 90; // PT
		$count = 0;
		//$w = 44.45; //mm  (126pt)
		//$w = 46.0248000000003; // MM (126pt + 4.464pt)
		//$w = 47.5996000000003; // MM (126pt + 4.464pt + 4.464pt)
		//$w = 46.8227833333336; // mm (126pt + 4.464pt + 2.232pt)
		$w = 126; // pt
		//$h = 6;
		$h = 2; //17;
		//$w_waste = 4.826; //4.38760; //mm (6.768pt)
		$w_waste = 7.0; //6.768; // pt
		$h_waste = 0;
		$origin_x = $pdf->GetX();
		$origin_y = $pdf->GetY();
		foreach ($lineLabels as $singleLabel) {
			$numLines = substr_count($singleLabel,"\n");
//			$h = ($stickerHeight/$numLines)-1;
			$h = $stickerHeight/($numLines+1);
			$x = $pdf->GetX();
			$y = $pdf->GetY();
			$pdf->multiCell($w, $h, $singleLabel, "1", "C");
//			$inPdf->RoundedRect($x, $y, $w, $h, '4.464pt', '1234','D');
//			$inPdf->RoundedBorderCell($w, $h, $label, '1', 'C');
//			$inPdf->RoundedBorderMultiCell($w, $h, $label, '1', 'C');
			$pdf->SetXY($x+$w, $y);
			if ($count < 3) {
				$x = $pdf->GetX();
				$y = $pdf->GetY();
				$pdf->multiCell($w_waste, $h_waste, "  ", 0, "C");
				$pdf->SetXY($x+$w_waste, $y);
				$count = $count + 1;
			}
		}
		$pdf->SetXY($origin_x, $origin_y+($h * 4));
	}
	
	function hs_ScountBookLabelPrint_labelCount ($inCol, $inRow, $inSelRow) {
		//echo "cookieValue: ".$inSelRow."<br>";
		for ($i = 1; $i < ($inCol * $inRow)+1; $i++) {
			if ($inSelRow == $i) {
				$selectedValue = 'selected="selected"';
			} else {
				$selectedValue = '';
			}
			echo ('<option value="'.$i.'" '.$selectedValue.' >'.$i.'</option>');
		}
	}
		
	function hs_ScoutBookLabelPrintMBAbbr($inItemName, $inXmlValues){
		$abbrName = $inItemName;
		$len = strlen($inItemName);
		foreach ($inXmlValues as $singleRow) {
			//echo ("list: ".$singleRow.":".$inItemName."<br>");
			//echo "1vs2: ".substr($singleRow, 0, $len).":".$inItemName."<br>";
			if ( strcmp(substr($singleRow, 0, $len),$inItemName) == 0 ) {
				$abbrName = substr($singleRow, $len+1);
				//echo "2vs3: ".substr($singleRow, 0, $len).":".$inItemName."::".$abbrName."<br>";
			}
		}
		//echo "return:".$abbrName."<br>";
		return $abbrName;
	}
		
	function hs_ScoutBookLabelPrint_newPage() {
		global	$fontSize;
		global	$labelRow;
		global	$numRow;
		global	$numCol;
		global	$colNum;
		global	$lineLabels;
		global	$pdf;
		global	$lineIsInProgress;

		$lineIsInProgress = true;
		if ($colNum >= $numCol) {
			$this->hs_ScoutBookLabelPrint_placeRowLabels();
			$lineLabels = array();
			$colNum = 0;
			$lineIsInProgress = false;
			$pdf->ln();
			$labelRow = $labelRow + 1;
		}
		if ($labelRow >= $numRow) {
			$pdf->AddPage('P','Letter');
			$pdf->SetFont('Arial','B',$fontSize);
			//$pdf->SetMargins(36, 36, 36);
			$colNum = 0;
			$labelRow = 0;
		}		
	}

	function hs_ScoutBookLabelPrint_Result ( ) {
		global	$colNum;
		global	$fontSize;
		global	$labelRow;
		global	$numRow;
		global	$numCol;
		global	$lineLabels;
		global	$pdf;
		global	$lineIsInProgress;
		
		if (isset($_POST['select-game'])) {
/*
    <Label-rectangle id="0" width="126pt" height="90pt" round="4.464pt" x_waste="6.768pt" y_waste="0pt">
      <Markup-margin size="9pt"/>
      <Layout nx="4" ny="8" x0="36pt" y0="36pt" dx="139.536pt" dy="90pt"/>
    </Label-rectangle>		
	36 + 126 + 6.768 + 126 + 6.768 + 126 + 6.768 + 126 + 36  = ? width
	
	36 + 90 + 0 + 90 + 0 + 90 + 0 + 90 + 0 + 90 + 0 + 90 + 0 + 90 + 0 + 90 + 36  = ? Height

	Name
	Message
	Merit Badge MB
	Councilname
	Troop 0008 Date mm/dd/yy
*/			
			if (isset($_FILES['csv_file']) && strlen($_FILES['csv_file']["tmp_name"])>0) {
				if (isset($_POST['CouncilName'])) {
					$councilName = $_POST['CouncilName'];
				} else {
					$councilName = "";
				}
				if (isset($_POST['UnitType'])) {
					$unitType = $_POST['UnitType'];
				} else {
					$unitType = "";
				}
				if (isset($_POST['UnitNumber'])) {
					$unitNumber = $_POST['UnitNumber'];
				} else {
					$unitNumber = "";
				}
				$labelDate = 'Date';
				
				$labelStyle = $_POST['LabelStyle'];
				$labelPos = $_POST['LabelPos'];
				$fontSize = $_POST['FontSize'];
				$numRow = $_POST['numRow'];
				$numCol = $_POST['numCol'];
				if (isset($_POST['rankMsg'])) {
					$rankMsg = $_POST['rankMsg'];
				} else {
					$rankMsg = "";
				}
				if (isset($_POST['mbMsg'])) {
					$mbMsg = $_POST['mbMsg'];
				} else {
					$mbMsg = "";
				}
				$row = 0;
				$colNum = 0;
				$labelRow = 0;
				$currentScount = "";
				
				// Create Cookies for selections
				if (isset($_COOKIE[HS_COOKIE_SBLP_LabelStyle])) {
					unset($_COOKIE[HS_COOKIE_SBLP_LabelStyle]);
				}
				if (isset($_COOKIE[HS_COOKIE_SBLP_UnitType]) && strlen($_COOKIE[HS_COOKIE_SBLP_UnitType]) > 0) {
					unset($_COOKIE[HS_COOKIE_SBLP_UnitType]);
				}
				if (isset($_COOKIE[HS_COOKIE_SBLP_UnitNumber])) {
					unset($_COOKIE[HS_COOKIE_SBLP_UnitNumber]);
				}
				if (isset($_COOKIE[HS_COOKIE_SBLP_FontSize])) {
					unset($_COOKIE[HS_COOKIE_SBLP_FontSize]);
				}
				if (isset($_COOKIE[HS_COOKIE_SBLP_LabelPosition])) {
					unset($_COOKIE[HS_COOKIE_SBLP_LabelPosition]);
				}
				if (isset($_COOKIE[HS_COOKIE_SBLP_Council])) {
					unset($_COOKIE[HS_COOKIE_SBLP_Council]);
				}
				if (isset($_COOKIE[HS_COOKIE_SBLP_RankMsg])) {
					unset($_COOKIE[HS_COOKIE_SBLP_RankMsg]);
				}
				if (isset($_COOKIE[HS_COOKIE_SBLP_MBMsg])) {
					unset($_COOKIE[HS_COOKIE_SBLP_MBMsg]);
				}

				$timeExpires = time() + (60 * 60 * 24 * 365);
				setcookie(HS_COOKIE_SBLP_LabelStyle, $labelStyle, $timeExpires);
				setcookie(HS_COOKIE_SBLP_UnitType, $unitType, $timeExpires);
				setcookie(HS_COOKIE_SBLP_UnitNumber, $unitNumber, $timeExpires);
				setcookie(HS_COOKIE_SBLP_FontSize, $fontSize, $timeExpires);
				setcookie(HS_COOKIE_SBLP_LabelPosition, $labelPos, $timeExpires);
				setcookie(HS_COOKIE_SBLP_Council, $councilName, $timeExpires);
				setcookie(HS_COOKIE_SBLP_RankMsg, $rankMsg, $timeExpires);
				setcookie(HS_COOKIE_SBLP_MBMsg, $mbMsg, $timeExpires);
/*				
				setcookie(HS_COOKIE_SBLP_LabelStyle, $labelStyle);
				setcookie(HS_COOKIE_SBLP_UnitType, $unitType);
				setcookie(HS_COOKIE_SBLP_UnitNumber, $unitNumber);
				setcookie(HS_COOKIE_SBLP_FontSize, $fontSize);
				setcookie(HS_COOKIE_SBLP_LabelPosition, $labelPos);
				setcookie(HS_COOKIE_SBLP_Council, $councilName);
				setcookie(HS_COOKIE_SBLP_RankMsg, $rankMsg);
				setcookie(HS_COOKIE_SBLP_MBMsg, $mbMsg);
*/				
				$list_ScoutName = array();
				$list_awardName = array();
				$list_Scout_Award = array();
				if (($handle = fopen($_FILES["csv_file"]["tmp_name"], "r")) !== FALSE) {
					$xmlValues = $this->hs_ScoutBookLabelPrint_loadXML();
					$meritBadgesAbbr = $this->hs_ScoutBookLabelPrint_loadMB($xmlValues);

					// Open PDF file for labels
					//$pdf = new FPDF();
					$pdf = new hs_ScoutBookLabelPrint_pdf('P','pt');
					$pdf->SetTitle('HoweScape ScoutBook Label Print');
					$pdf->SetAuthor('http://HoweScape.com');
					$pdf->SetTitleFileName($_FILES["csv_file"]["name"]);
					//$pdf->SetMargins(6.35, 6.35, 6.35);
					//$pdf->SetMargins(4.25, 4.25, 4.25);
					$pdf->SetMargins(36, 36, 36); // PT
					$pdf->AddPage('P','Letter');
					$pdf->SetFont('Arial','B',$fontSize);
					
					$pdf->SetAutoPageBreak(false);
					// Open award list file for labels
					$pdf_list = new FPDF();
					$pdf_list->AddPage('P','Letter');
					$pdf_list->SetFont('Arial','B',12);
					$labels = array();
					$lineIsInProgress = false;
//					foreach ($meritBadgesAbbr as $c) {
//						echo "first: ".$c."<br>";
//					}
					$colNum = 0;
						// Add Blank blocks
						for ($i = 1; $i < $labelPos; $i++) {
							if ($colNum <= $numCol) {
								$labels[] = " ".HS_MSG_NEWLINE.
											" ".HS_MSG_NEWLINE.
											" ".HS_MSG_NEWLINE.
											" ".HS_MSG_NEWLINE;
								$colNum = $colNum + 1;
								$this->hs_ScoutBookLabelPrint_newPage();

							}
						}
					while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
						$num = count($data);
//						echo "<p> $num fields in line $row: <br /></p>\n";
						$row++;
						
						if ($row > 1) {
							$scoutName = $data[0].' '.$data[1];
							$itemType = $data[5];
							$itemName = $data[7];
							$itemName = $this->hs_ScoutBookLabelPrintMBAbbr($itemName, $meritBadgesAbbr);
							$itemDate = $data[8];
							// Store infor in array for list page
							$list_ScoutName[] = $scoutName;
							$list_awardName[] = $itemName;
							//$singleAward = array ($scoutName => $itemName);
							//$list_Scout_Award = array_merge($list_Scout_Award, $singleAward);
							// end store list in page
							// output info to list page
//							if (strcmp($scoutName, $currentScount) != 0) {
//								$currentScount = $scoutName;
//								$pdf_list->cell(40, 10, $scoutName);
//							}
//							$pdf_list->ln();
//							$pdf_list->cell(40, 10, "");							
//							$pdf_list->cell(40, 10, $itemName);
//							$pdf_list->ln();
							// end output list
							$councilName = $_POST["CouncilName"];
							$date = date_create($data[8]);
							$formattedDate = date_format($date, "m/d/y");
							if (strcmp ($itemType, HS_CSV_MERIT_BADGE) == 0) {
								$labelMsg = str_replace(HS_MSG_MERITBADGE, $itemName, $mbMsg);
								$labelMsg = str_replace(HS_MSG_NL, HS_MSG_NEWLINE, $labelMsg);
							} elseif (strcmp($itemType, HS_CSV_RANK) == 0) {
								$labelMsg = str_replace(HS_MSG_RANK, $itemName, $rankMsg);
								$labelMsg = str_replace(HS_MSG_NL, HS_MSG_NEWLINE, $labelMsg);
							} else {
								$labelMsg = $itemName;
							}
							$labelMsg = str_replace(HS_MSG_EMBLEM, '', $labelMsg);
//							$formattedDate = $data[8];
							$unitTypeNumDate = $unitType.' '.$unitNumber.' '.$labelDate.' '.$formattedDate;
							$multiLines = $scoutName.HS_MSG_NEWLINE.
										  $labelMsg.HS_MSG_NEWLINE.
										  $councilName.HS_MSG_NEWLINE.
										  $unitTypeNumDate;
							$lineLabels[] = $multiLines;
							$colNum = $colNum + 1;
							$this->hs_ScoutBookLabelPrint_newPage();

						} 
					} 
					if ($lineIsInProgress == true) {
								$this->hs_ScoutBookLabelPrint_placeRowLabels();
								$labels = array();
								$col = 0;
								$pdf->ln();
								$labelRow = $labelRow + 1;
					}
					$outputFile = plugin_dir_path( __FILE__ ) .'mysample.pdf';
					$outputFile_list = plugin_dir_path( __FILE__ ) .'mysample_list.pdf';
					//$inputFileName = $_FILES["csv_file"]["tmp_name"];
					//$outputFile = plugin_dir_path( __FILE__ ) .$inputFileName.".pdf";
					//$outputFile_list = plugin_dir_path( __FILE__ ) .$inputFileName."_lists.pdf";
					
					// Add list at end of labels
					$currentScout = '';
					$pdf->AddPage('P','Letter');
					$pageHeight = $pdf->GetPageHeight();
					$pageUsed = 0;
					//$listSize = sizeof($list_Scout_Award);
					$listSize = sizeof($list_ScoutName);

					for($i=0; $i<$listSize-1; $i++) {
						$scout = $list_ScoutName[$i];
						$award = $list_awardName[$i];
						if (strcmp($scout, $currentScout) != 0) {
							$numLinesForScout = $this->hs_ScoutBookLabelPrint_listLineCount ($list_ScoutName, $scout);
						}
						if ($pageUsed + ($numLinesForScout * 5) + 5 > $pageHeight) {
							$pdf->AddPage('P','Letter');
							$pageHeight = $pdf->GetPageHeight();
							$pageUsed = 0;
						}
						if (strcmp($scout, $currentScout) != 0) {
							$currentScout = $scout;
							$pdf->cell(100, 20, "  ", 'B');
							$pdf->cell(100, 20, "  ", 'B');
							$pdf->cell(100, 20, "  ", 'B');
							$pdf->ln();
							$pageUsed = $pageUsed + 20;
							$pdf->cell(100, 20, $scout, 'T');
							$pdf->cell(100, 20, "  ", 'T');
							$pdf->cell(100, 20, "  ", 'T');
							$pdf->ln();
							$pageUsed = $pageUsed + 20;
						}
						$pdf->cell(100, 15, "");							
						$pdf->cell(100, 15, $award);
						$pdf->ln();
						$pageUsed = $pageUsed + 15;
						
						if ($pageUsed + 15 > $pageHeight) {
							$pdf->AddPage('P','Letter');
							$pageHeight = $pdf->GetPageHeight();
							$pageUsed = 0;
						}
					}
/*					foreach ($list_Scout_Award as $scout => $award) {
//						echo " list value".$scout." => ".$award."<br>";
						if (strcmp($scout, $currentScout) != 0) {
								$currentScout = $scout;
								$pdf->cell(40, 10, $scout);
							}
							$pdf->ln();
							$pdf->cell(40, 10, "");							
							$pdf->cell(40, 10, $award);
							$pdf->ln();
					}
*/					// End of lists

//					echo " outfile: ".$outputFile."<br>";
//					$pdf->Output('F', $outputFile);
//					$pdf_list->Output('F', $outputFile_list);

					$pdf->Output('I');
//					$pdf_list->Output('I');
//					$pdf->Output('D', $outputFile);
//					$pdf_list->Output('D', $outputFile_list);

//					$merge = new FPDF_Merge();
//					$merge->add($pdf->Output('S'));
//					$merge->add($pdf_list->Output('S'));
//					$merge->add('mysample.pdf');
//					$merge->add('mysample_list.pdf');
//					$merge->output('I');
					
					fclose($handle);
				}
			} 
		}
	}
	
	function hs_ScoutBookLabelPrint_listLineCount ($list_ScoutName, $scout){
		$listSize = sizeof($list_ScoutName);
		$nameCount = 0;
		for ($i = 0; $i < $listSize; $i++) {
			if (strcmp($scout, $list_ScoutName[$i])==0) {
				$nameCount = $nameCount + 1;
			}
		}
		return $nameCount;
	}
	
	function hs_ScoutBookLabelPrint_code ( $attr ) {
		global	$numCol;
		global	$fontSize;
		global	$wpdb;
		global	$numRow;
		$unitNumber = "";
		$meritBadgesAbbr = array();
		
//		if (isset($_POST['select-game'])) {
/*
    <Label-rectangle id="0" width="126pt" height="90pt" round="4.464pt" x_waste="6.768pt" y_waste="0pt">
      <Markup-margin size="9pt"/>
      <Layout nx="4" ny="8" x0="36pt" y0="36pt" dx="139.536pt" dy="90pt"/>
    </Label-rectangle>		
	36 + 126 + 6.768 + 126 + 6.768 + 126 + 6.768 + 126 + 36  = ? width
	
	36 + 90 + 0 + 90 + 0 + 90 + 0 + 90 + 0 + 90 + 0 + 90 + 0 + 90 + 0 + 90 + 36  = ? Height

	Name
	Message
	Merit Badge MB
	Councilname
	Troop 0008 Date mm/dd/yy
*/
		$xmlValues = $this->hs_ScoutBookLabelPrint_loadXML();
		$xmlLabelTemplates = $this->hs_ScoutBookLabelPrint_loadTemplate();
		$meritBadgesAbbr = $this->hs_ScoutBookLabelPrint_loadMB($xmlValues);
				
		// Display list of available text games
		$my_listTitle = __('HoweScape ScoutBook Label Print', 'hs_ScoutBookLabelPrint');
		$my_buttonValue = __('Load CSV', 'hs_ScoutBookLabelPrint');
		$my_scoutBookCsv = __('Scout Book CSV:');
		$my_labelStyle = __('Label Style:');
		$my_unitType = __('Unit Type:');
		$my_unitNum = __('Unit Number:');
		$my_fontSize = __('Font Size:');
		$my_labelPos = __('Label Position:');
		$my_council = __('Council:');
		$my_rankMsg = __('Rank Message');
		$my_mbMsg = __('MeritBadge Message');

		$label_Columns = 4;
		$label_Rows = 8;
//		if (isset($_COOKIE[HS_COOKIE_SBLP_RankMsg])) {
//			echo " post rank Msg: ".$_POST['rankMsg'].":<br>";
//			$rankMsg = $_COOKIE[HS_COOKIE_SBLP_RankMsg];
//		} else {
//			echo " Empty post rank Msg: ".$_POST['rankMsg'].":<br>";
//			$rankMsg = "";
//		}
//		if (isset($_COOKIE[HS_COOKIE_SBLP_MBMsg])) {
//			$mbMsg = $_COOKIE[HS_COOKIE_SBLP_MBMsg];
//		} else {
//			$mbMsg = "";
//		}
//		$mbMsg = "";
		if (isset($rankMsg)) {
		} else {
			$rankMsg = "";
		}
		if (isset($mbMsg)) {
		} else {
			$mbMsg = "";
		}
		if (strlen($unitNumber) == 0) {
			$unitNumber = '0001';
		}

		// Check if cookie value is available to restore value
		if (isset($_COOKIE[HS_COOKIE_SBLP_LabelStyle])) {
			//unset($_COOKIE[HS_COOKIE_SBLP_LabelStyle]);
		}
		if (isset($_COOKIE["HS_ScoutBook_UnitType"]) && strlen($_COOKIE["HS_ScoutBook_UnitType"]) > 0) {
//			print_r($_COOKIE['HS_ScoutBook_UnitType']);
//			print_r($_COOKIE);
			$unitType = $_COOKIE[HS_COOKIE_SBLP_UnitType];
		}
		if (isset($_COOKIE[HS_COOKIE_SBLP_UnitNumber])) {
			$unitNumber = $_COOKIE[HS_COOKIE_SBLP_UnitNumber];
		}
		if (isset($_COOKIE[HS_COOKIE_SBLP_FontSize])) {
			$fontSize = $COOKIE[HS_COOKIE_SBLP_FontSize];
		}
		if (isset($_COOKIE[HS_COOKIE_SBLP_LabelPosition])) {
			$labelPos = $_COOKIE[HS_COOKIE_SBLP_LabelPosition];
		}
		if (isset($_COOKIE[HS_COOKIE_SBLP_Council])) {
			$councilName = $_COOKIE[HS_COOKIE_SBLP_Council];
		}
		if (isset($_COOKIE[HS_COOKIE_SBLP_RankMsg])) {
			$rankMsg = $_COOKIE[HS_COOKIE_SBLP_RankMsg];
		}
		if (isset($_COOKIE[HS_COOKIE_SBLP_MBMsg])) {
			$mbMsg = $_COOKIE[HS_COOKIE_SBLP_MBMsg];
		}
		
		echo ('<h2>'.$my_listTitle.'</h2>');
	
		echo('<form id="" target="_Blank" method="POST" enctype="multipart/form-data" action="'.esc_url(admin_url('admin-post.php')).'">');
		echo('<input type="hidden" name="action" value="hs_ScoutBookLabelPrint_Result">');
		echo('<input type="hidden" name="numCol" value="'.$label_Columns.'" />');
		echo('<input type="hidden" name="numRow" value="'.$label_Rows.'" />');
		// Build Table of controls
		echo('<div class="div-table">');
			echo ('<div class="div-table-row">');
				echo ('<div class="div-table-col">'.$my_scoutBookCsv.'</div>');
				echo ('<div class="div-table-col"><input type="file" name="csv_file" /></div>');
			echo ('</div>');
			echo ('<div class="div-table-row">');
				echo ('<div class="div-table-col">'.$my_labelStyle.'</div>');
				echo ('<div class="div-table-col"><select name="LabelStyle">');
				echo ('<option value="6570">Avery 6570</option></select></div>');
			echo ('</div>');
			echo ('<div class="div-table-row">');
				echo ('<div class="div-table-col">'.$my_unitType.'</div>');
				echo ('<div class="div-table-col"><select name="UnitType">');
					$this->hs_ScoutBookLabelPrint_loadUnits($xmlValues, $unitType);
				echo ('</select></div>');
			echo ('</div>');
			echo ('<div class="div-table-row">');
				echo ('<div class="div-table-col">'.$my_unitNum.'</div>');
				echo ('<div class="div-table-col"><Input type="text" name="UnitNumber" value="'.$unitNumber.'"></div>');
			echo ('</div>');
			echo ('<div class="div-table-row">');
				echo ('<div class="div-table-col">'.$my_fontSize.'</div>');
				echo ('<div class="div-table-col"><select name="FontSize">');
				$this->hs_ScoutBookLabelPrint_loadFonts($xmlValues, $fontSize);
				echo ('</select></div>');
			echo ('</div>');
			echo ('<div class="div-table-row">');
				echo ('<div class="div-table-col">'.$my_labelPos.'</div>');
				echo ('<div class="div-table-col"><select name="LabelPos">');
				$this->hs_ScountBookLabelPrint_labelCount($label_Columns, $label_Rows, $labelPos);
				echo ('</select></div>');
			echo ('</div>');
			echo ('<div class="div-table-row">');
				echo ('<div class="div-table-col">'.$my_council.'</div>');
				echo ('<div class="div-table-col"><select name="CouncilName">');
				$this->hs_ScoutBookLabelPrint_loadCouncil($councilName);
				echo ('</select></div>');
			echo ('</div>');
			echo ('<div class="div-table-row">');
				echo ('<div class="div-table-col">'.$my_rankMsg.'</div>');
				echo ('<div class="div-table-col"><Input type="text" name="rankMsg" value="');
				$this->hs_ScoutBookLabelPrint_loadMsg($xmlValues, 2, $rankMsg);
				echo ('"></select></div>');
			echo ('</div>');
			echo ('<div class="div-table-row">');
				echo ('<div class="div-table-col">'.$my_mbMsg.'</div>');
				echo ('<div class="div-table-col"><Input type="text" name="mbMsg" value="');
				$this->hs_ScoutBookLabelPrint_loadMsg($xmlValues, 3, $mbMsg);
				echo ('"></select></div>');
			echo ('</div>');
			echo ('<div class="div-table-span-col">');
				echo ('<div class="div-table-span-col"><input type="submit" name="select-game" value="'.$my_buttonValue.'" class="button button-primary"/></div>');
			echo ('</div>');			
		echo('</div>');		
		echo('</form>');
	}
		
	public function __Construct() {
		global	$fontSize;
		global	$numRow;
		global	$labelRow;
		global	$colNum;
		global	$lineLabels;
		global	$pdf;

		$lineLabels = array();
		// Register Database
		
		// Add Javascript and CSS for admin screens
//		add_action('admin_enquene_scripts', array($this, 'load_custom_wp_admin_style'));

        // Add Javascript and CSS for front-end display
		add_action('wp_enqueue_scripts', array($this, 'load_js_css'));

		add_action( 'admin_post_hs_ScoutBookLabelPrint_Result', array($this, 'hs_ScoutBookLabelPrint_Result') );
		add_action( 'admin_post_nopriv_hs_ScoutBookLabelPrint_Result', array($this, 'hs_ScoutBookLabelPrint_Result') );

//		add_action('admin_menu', array($this,'hs_ScoutBookLabelPrint_admin'));
		
		// Translation Link
//		add_action ('plugins_loaded', array($this,'hs_ScoutBookLabelPrint_load_textDomain'));

		add_shortcode('hs_ScoutBookLabelPrint', array($this, 'hs_ScoutBookLabelPrint_code'));
	}
}

// Variable of plugin object
global	$hs_ScoutBookLabelPrint_obj;

// Create an instance of the class to kick off the whole thing
$hs_ScoutBookLabelPrint_obj = new hs_ScoutBookLabelPrint();
?>